var information_for_contributors = [
	"This file has been converted from https://github.com/redhat-developer/vscode-java/blob/master/",
	"If you want to provide a fix or improvement, please create a pull request against the original repository.",
	"Once accepted there, we are happy to receive an update request."
];
var version = "https://github.com/textmate/java.tmbundle/blob/79b8b61865e40de0ff04bb16fe1076b154b9894c/Syntaxes/JavaProperties.plist";
var fileTypes = [
	"properties"
];
var foldingStartMarker = "^[a-zA-Z0-9.-_]+=.*\\\r\n";
var foldingStopMarker = "^(.*(?<!\\)\r\n)";
var keyEquivalent = "^~J";
var name = "Java Properties";
var patterns = [
	{
		comment: "Ignore blank lines",
		match: "^\\s*$"
	},
	{
		include: "#comment-line"
	},
	{
		include: "#property-name"
	},
	{
		include: "#property-definition"
	}
];
var repository = {
	"comment-line": {
		captures: {
			"1": {
				name: "punctuation.whitespace.comment.leading.java-properties"
			},
			"2": {
				name: "punctuation.definition.comment.java-properties"
			}
		},
		match: "^(\\s*)([#!])(.+)?$\\n?",
		name: "comment.line.java-properties"
	},
	"property-definition": {
		begin: "^(\\s*)((?:\\\\[ \\t]|\\\\:|\\\\=|[^:=\\s])+)(?:\\s*([:=]))?\\s*",
		beginCaptures: {
			"1": {
				name: "punctuation.whitespace.leading.java-properties"
			},
			"2": {
				name: "support.constant.java-properties",
				patterns: [
					{
						match: "\\\\(?:[ \\t:=\\\\ntfr\\\"']|u[0-9A-Fa-f]{4})",
						name: "constant.character.escape.java-properties"
					}
				]
			},
			"3": {
				name: "punctuation.separator.key-value.java-properties"
			}
		},
		contentName: "string.unquoted.java-properties",
		end: "(?<!\\\\{1})$\\n",
		name: "meta.key-value.java-properties",
		patterns: [
			{
				comment: "Leading space on a continued line is ignored",
				match: "^\\s*",
				name: "punctuation.whitespace.leading.java-properties"
			},
			{
				match: "(\\\\{1})(?=$\\n)",
				name: "punctuation.separator.continuation.java-properties"
			},
			{
				match: "\\\\(?:[\\\\ntfr\\\"']|u[0-9A-Fa-f]{4})",
				name: "constant.character.escape.java-properties"
			}
		]
	},
	"property-name": {
		captures: {
			"1": {
				name: "punctuation.whitespace.comment.leading.java-properties"
			},
			"2": {
				name: "support.constant.java-properties",
				patterns: [
					{
						match: "\\\\(?:[ \\t:=\\\\ntfr\\\"']|u[0-9A-Fa-f]{4})",
						name: "constant.character.escape.java-properties"
					}
				]
			}
		},
		comment: "A property name with no value",
		match: "^(\\s*)((?:\\\\[ \\t]|\\\\:|\\\\=|[^:=\\s])+)(?:\\s*([:=]))?\\s*$\\n",
		name: "meta.key-value.java-properties"
	}
};
var scopeName = "source.java-properties";
var uuid = "D364E829-7643-4AFF-948D-3C0D6B4EA8A4";
var JavaProperties_tmLanguage = {
	information_for_contributors: information_for_contributors,
	version: version,
	fileTypes: fileTypes,
	foldingStartMarker: foldingStartMarker,
	foldingStopMarker: foldingStopMarker,
	keyEquivalent: keyEquivalent,
	name: name,
	patterns: patterns,
	repository: repository,
	scopeName: scopeName,
	uuid: uuid
};

export { JavaProperties_tmLanguage as default, fileTypes, foldingStartMarker, foldingStopMarker, information_for_contributors, keyEquivalent, name, patterns, repository, scopeName, uuid, version };
