var fileTypes = [
];
var injectionSelector = "L:text.html.rmarkdown";
var patterns = [
	{
		include: "#block"
	},
	{
		include: "#inline"
	}
];
var repository = {
	block: {
		patterns: [
			{
				include: "#fenced_block_r"
			},
			{
				include: "#fenced_block_c"
			},
			{
				include: "#fenced_block_cpp"
			},
			{
				include: "#fenced_block_yaml"
			},
			{
				include: "#fenced_block"
			},
			{
				include: "#fenced_block_julia"
			},
			{
				include: "#fenced_block_stan"
			},
			{
				include: "#fenced_block_python"
			},
			{
				include: "#fenced_block_sql"
			},
			{
				include: "#fenced_block_css"
			},
			{
				include: "#fenced_block_scss"
			},
			{
				include: "#fenced_block_js"
			},
			{
				include: "#link-def"
			},
			{
				include: "#html"
			},
			{
				include: "#paragraph"
			}
		],
		repository: {
			fenced_block_c: {
				begin: "(^|\\G)([`]{3})\\{*[ ]*(?:c|C)\\s*\\}*$",
				end: "(^|\\G)([`]{3})($|\\z)",
				name: "meta.embedded.block.c",
				patterns: [
					{
						include: "source.c"
					}
				]
			},
			fenced_block_cpp: {
				begin: "(^|\\G)([`]{3})\\{*[ ]*(?:cpp|c\\+\\+|C\\+\\+).*\\}*$",
				end: "(^|\\G)([`]{3})($|\\z)",
				name: "meta.embedded.block.cpp",
				patterns: [
					{
						include: "source.cpp"
					}
				]
			},
			fenced_block_r: {
				begin: "(^|\\G)([`]{3})\\{*[ ]*(?:r|R).*\\}*$",
				end: "(^|\\G)([`]{3})($|\\z)",
				name: "meta.embedded.block.r",
				patterns: [
					{
						include: "source.r"
					}
				]
			},
			fenced_block_yaml: {
				begin: "(^|\\G)([`]{3})\\{*[ ]*(?:yaml|YAML).*\\}*$",
				end: "(^|\\G)([`]{3})($|\\z)",
				name: "meta.embedded.block.yaml",
				patterns: [
					{
						include: "source.yaml"
					}
				]
			},
			fenced_block_julia: {
				begin: "(^|\\G)([`]{3})\\{*[ ]*(?:julia).*\\}*$",
				end: "(^|\\G)([`]{3})($|\\z)",
				name: "meta.embedded.block.julia",
				patterns: [
					{
						include: "source.julia"
					}
				]
			},
			fenced_block_stan: {
				begin: "(^|\\G)([`]{3})\\{*[ ]*(?:stan).*\\}*$",
				end: "(^|\\G)([`]{3})($|\\z)",
				name: "meta.embedded.block.stan",
				patterns: [
					{
						include: "source.stan"
					}
				]
			},
			fenced_block_python: {
				begin: "(^|\\G)([`]{3})\\{*[ ]*(?:python).*\\}*$",
				end: "(^|\\G)([`]{3})($|\\z)",
				name: "meta.embedded.block.python",
				patterns: [
					{
						include: "source.python"
					}
				]
			},
			fenced_block_sql: {
				begin: "(^|\\G)([`]{3})\\{*[ ]*(?:sql).*\\}*$",
				end: "(^|\\G)([`]{3})($|\\z)",
				name: "meta.embedded.block.sql",
				patterns: [
					{
						include: "source.sql"
					}
				]
			},
			fenced_block_css: {
				begin: "(^|\\G)([`]{3})\\{*[ ]*(?:css).*\\}*$",
				end: "(^|\\G)([`]{3})($|\\z)",
				name: "meta.embedded.block.css",
				patterns: [
					{
						include: "source.css"
					}
				]
			},
			fenced_block_scss: {
				begin: "(^|\\G)([`]{3})\\{*[ ]*(?:scss).*\\}*$",
				end: "(^|\\G)([`]{3})($|\\z)",
				name: "meta.embedded.block.css.scss",
				patterns: [
					{
						include: "source.css.scss"
					}
				]
			},
			fenced_block_js: {
				begin: "(^|\\G)([`]{3})\\{*[ ]*(?:js).*\\}*$",
				end: "(^|\\G)([`]{3})($|\\z)",
				name: "meta.embedded.block.js",
				patterns: [
					{
						include: "source.js"
					}
				]
			}
		}
	},
	inline: {
		patterns: [
			{
				include: "#code-inline-r"
			}
		],
		repository: {
			"code-inline-r": {
				begin: "(`[r|R][ ]+)",
				beginCaptures: {
					"1": {
						name: "punctuation.definition.raw.rmarkdown"
					}
				},
				end: "(`)",
				endCaptures: {
					"1": {
						name: "punctuation.definition.raw.rmarkdown"
					}
				},
				contentName: "meta.embedded.block.r",
				patterns: [
					{
						include: "source.r"
					}
				]
			}
		}
	}
};
var scopeName = "text.html.markdown.redcarpet";
var uuid = "BE79A69A-B9F5-4BCD-9068-893496E86663";
var information_for_contributors = [
	"This file has been converted from https://github.com/REditorSupport/vscode-R/blob/master/",
	"If you want to provide a fix or improvement, please create a pull request against the original repository.",
	"Once accepted there, we are happy to receive an update request."
];
var Markdown_Redcarpet = {
	fileTypes: fileTypes,
	injectionSelector: injectionSelector,
	patterns: patterns,
	repository: repository,
	scopeName: scopeName,
	uuid: uuid,
	information_for_contributors: information_for_contributors
};

export { Markdown_Redcarpet as default, fileTypes, information_for_contributors, injectionSelector, patterns, repository, scopeName, uuid };
