var fileTypes = [
	"cabal"
];
var name = "Cabal";
var patterns = [
	{
		name: "keyword.other.cabal",
		match: "(?ix)(\\n|^)\n                ( name\n                | version\n                | cabal-version\n                | build-type\n                | license(-file)?\n                | copyright\n                | author\n                | maintainer\n                | stability\n                | homepage\n                | bug-reports\n                | package-url\n                | synopsis\n                | data-(files|dir)\n                | description\n                | category\n                | extra-(source|doc|tmp)-files\n                | tested-with\n                ):\n            "
	},
	{
		name: "keyword.other.cabal",
		match: "(?ix)^[ \\t]+\n                ( build-depends\n                | other-modules\n                | hs-source-dirs\n                | ((other|default)-)?extensions\n                | build-tools\n                | buildable\n                | ghc(-(prof|shared))?-options\n                | (install-)?includes\n                | include-dirs\n                | (c|js)-sources\n                | extra(-ghci)?-libraries\n                | extra-lib-dirs\n                | (cc|cpp|ld)-options\n                | pkgconfig-depends\n                | default-language\n                | frameworks\n                | default\n                | manual\n                | location\n                | branch\n                | tag\n                | subdir\n                | exposed(-modules)?\n                | reexported-modules\n                | main-is\n                | type\n                | test-module\n                | description\n                | setup-depends\n                | mixins\n                | import\n                | autogen-modules\n                ):\n            "
	},
	{
		name: "keyword.operator.cabal",
		match: "(==|>=|<=|<|>|\\|\\||&&|!)"
	},
	{
		name: "constant.numeric.cabal",
		match: "(?<=[^\\w])\\d+(\\.\\d+)*(\\.\\*)?"
	},
	{
		name: "markup.underline.link.cabal",
		match: "\\w+:/(/[\\w._\\-\\d%])+(\\?[\\w.+_\\-\\d%]+)(&[\\w._+\\-\\d%]+)*"
	},
	{
		name: "entity.name.section.cabal",
		match: "^(?ix:\n                ( library\n                | custom-setup\n                ))$"
	},
	{
		match: "^(?ix:\n                ( executable\n                | flag\n                | test-suite\n                | benchmark\n                | common\n                | source-repository\n                ))( |\\t)+([\\w\\-_]+)$",
		captures: {
			"1": {
				name: "entity.name.section.cabal"
			},
			"3": {
				name: "entity.name.function.cabal"
			}
		}
	},
	{
		name: "keyword.control.cabal",
		match: "^[ \\t]*(if|else)"
	},
	{
		name: "comment.line.double-dash",
		match: "^\\s*--.*$"
	}
];
var scopeName = "source.cabal";
var uuid = "5eb56f02-df11-40b2-b6d5-fa444522416c";
var information_for_contributors = [
	"This file has been converted from https://github.com/JustusAdam/language-haskell/blob/df29e5733bd5b31c59af7404306e0759431c33ea/",
	"If you want to provide a fix or improvement, please create a pull request against the original repository.",
	"Once accepted there, we are happy to receive an update request."
];
var cabal_tmLanguage = {
	fileTypes: fileTypes,
	name: name,
	patterns: patterns,
	scopeName: scopeName,
	uuid: uuid,
	information_for_contributors: information_for_contributors
};

export { cabal_tmLanguage as default, fileTypes, information_for_contributors, name, patterns, scopeName, uuid };
