var scopeName = "debian-control.r";
var patterns = [
	{
		include: "#keyword"
	},
	{
		include: "#comment"
	},
	{
		include: "#email"
	},
	{
		include: "#substvar"
	},
	{
		include: "#block"
	}
];
var repository = {
	keyword: {
		patterns: [
			{
				comment: "keyword",
				match: "^(?!(Authors@R:|linters:|exclusions:)).*?:",
				name: "keyword.control"
			}
		]
	},
	comment: {
		patterns: [
			{
				comment: "comment",
				match: "^#.*$",
				name: "comment.line.number-sign"
			}
		]
	},
	substvar: {
		patterns: [
			{
				comment: "substvar",
				match: "[$][{].+[}]",
				name: "variable.parameter"
			}
		]
	},
	email: {
		patterns: [
			{
				comment: "email",
				match: "<.+@.+[.].+>",
				name: "variable.language"
			}
		]
	},
	block: {
		patterns: [
			{
				include: "#code-block-r"
			}
		],
		repository: {
			"code-block-r": {
				begin: "^(Authors@R:|linters:|exclusions:)",
				beginCaptures: {
					"1": {
						name: "keyword.control"
					}
				},
				end: "^(?!\\s)",
				contentName: "meta.embedded.block.r",
				patterns: [
					{
						include: "source.r"
					}
				]
			}
		}
	}
};
var information_for_contributors = [
	"This file has been converted from https://github.com/REditorSupport/vscode-R/blob/master/",
	"If you want to provide a fix or improvement, please create a pull request against the original repository.",
	"Once accepted there, we are happy to receive an update request."
];
var dcf = {
	scopeName: scopeName,
	patterns: patterns,
	repository: repository,
	information_for_contributors: information_for_contributors
};

export { dcf as default, information_for_contributors, patterns, repository, scopeName };
