var cond = {
	prefix: "cond",
	body: "cond do\n\t$1 ->\n\t\t$0\nend",
	description: "cond",
	scope: "source.elixir"
};
var def = {
	prefix: "def",
	body: "def $1 do\n\t$0\nend",
	description: "def",
	scope: "source.elixir"
};
var test = {
	prefix: "test",
	body: "test $1 do\n\t$0\nend",
	description: "test",
	scope: "source.elixir"
};
var describe = {
	prefix: "describe",
	body: "describe $1 do\n\t$0\nend",
	description: "describe",
	scope: "source.elixir"
};
var defc = {
	prefix: "defcallback",
	body: "defcallback $1 :: $0",
	description: "defcallback",
	scope: "source.elixir"
};
var defd = {
	prefix: "defdelegate",
	body: "defdelegate $1 to: $0",
	description: "defdelegate",
	scope: "source.elixir"
};
var defe = {
	prefix: "defexception",
	body: "defexception [${1::message}]",
	description: "defexception",
	scope: "source.elixir"
};
var defi = {
	prefix: "defimpl",
	body: "defimpl $1, for: $2 do\n  $0\nend",
	description: "defimpl",
	scope: "source.elixir"
};
var defg = {
	prefix: "defguard",
	body: "defguard ${1:guard_name}($2) when $3",
	description: "defguard",
	scope: "source.elixir"
};
var defgp = {
	prefix: "defguardp",
	body: "defguardp ${1:guard_name}($2) when $3",
	description: "defguardp",
	scope: "source.elixir"
};
var defm = {
	prefix: "defmacro",
	body: "defmacro $1 do\n\t$0\nend",
	description: "defmacro",
	scope: "source.elixir"
};
var defmc = {
	prefix: "defmacrocallback",
	body: "defmacrocallback $1 :: $0",
	description: "defmacrocallback",
	scope: "source.elixir"
};
var defmp = {
	prefix: "defmacrop",
	body: "defmacrop $1 do\n\t$0\nend",
	description: "defmacrop",
	scope: "source.elixir"
};
var defmod = {
	prefix: "defmodule",
	body: "defmodule $1 do\n\t$0\nend",
	description: "defmodule",
	scope: "source.elixir"
};
var defp = {
	prefix: "defp",
	body: "defp $1 do\n\t$0\nend",
	description: "defp",
	scope: "source.elixir"
};
var defpro = {
	prefix: "defprotocol",
	body: "defprotocol $1 do\n  $0\nend",
	description: "defprotocol",
	scope: "source.elixir"
};
var defs = {
	prefix: "defstruct",
	body: "defstruct $1: $2",
	description: "defstruct",
	scope: "source.elixir"
};
var doc = {
	prefix: "@doc",
	body: "@doc \"\"\"\n$0\n\"\"\"",
	description: "doc",
	scope: "source.elixir"
};
var i = {
	prefix: "i",
	body: "inspect($0)",
	description: "IO.inspect",
	scope: "source.elixir"
};
var ii = {
	prefix: "ii",
	body: "IO.inspect($0)",
	description: "IO.inspect",
	scope: "source.elixir"
};
var mdoc = {
	prefix: "@moduledoc",
	body: "@moduledoc \"\"\"\n$0\n\"\"\"",
	description: "moduledoc",
	scope: "source.elixir"
};
var spec = {
	prefix: "@spec",
	body: "@spec $0",
	description: "spec",
	scope: "source.elixir"
};
var rec = {
	prefix: "receive",
	body: "receive do\n\t${1:{${2::message_type}, ${3:value}\\}} ->\n    ${0:# code}\nend\n",
	description: "receive",
	scope: "source.elixir"
};
var req = {
	prefix: "require",
	body: "require $0",
	description: "require",
	scope: "source.elixir"
};
var elixirSnippets = {
	"case": {
	prefix: "case",
	body: "case $1 do\n\t$2 ->\n\t\t$0\nend",
	description: "case",
	scope: "source.elixir"
},
	cond: cond,
	def: def,
	test: test,
	describe: describe,
	defc: defc,
	defd: defd,
	defe: defe,
	defi: defi,
	defg: defg,
	defgp: defgp,
	defm: defm,
	defmc: defmc,
	defmp: defmp,
	defmod: defmod,
	defp: defp,
	defpro: defpro,
	defs: defs,
	"do": {
	prefix: "do",
	body: "do\n\t$0\nend",
	descripton: "do/end block",
	scope: "source.elixir"
},
	doc: doc,
	i: i,
	ii: ii,
	mdoc: mdoc,
	spec: spec,
	rec: rec,
	req: req
};

export { cond, def, elixirSnippets as default, defc, defd, defe, defg, defgp, defi, defm, defmc, defmod, defmp, defp, defpro, defs, describe, doc, i, ii, mdoc, rec, req, spec, test };
