var scopeName = "inline-styles.ng";
var injectionSelector = "L:source.ts#meta.decorator.ts -comment";
var patterns = [
	{
		include: "#inlineStyles"
	}
];
var repository = {
	inlineStyles: {
		begin: "(styles)\\s*(:)",
		beginCaptures: {
			"1": {
				name: "meta.object-literal.key.ts"
			},
			"2": {
				name: "meta.object-literal.key.ts punctuation.separator.key-value.ts"
			}
		},
		end: "(?=,|})",
		patterns: [
			{
				include: "#tsParenExpression"
			},
			{
				include: "#tsBracketExpression"
			}
		]
	},
	tsParenExpression: {
		begin: "\\G\\s*(\\()",
		beginCaptures: {
			"1": {
				name: "meta.brace.round.ts"
			}
		},
		end: "\\)",
		endCaptures: {
			"0": {
				name: "meta.brace.round.ts"
			}
		},
		patterns: [
			{
				include: "$self"
			},
			{
				include: "#tsBracketExpression"
			}
		]
	},
	tsBracketExpression: {
		begin: "\\G\\s*(\\[)",
		beginCaptures: {
			"1": {
				name: "meta.array.literal.ts meta.brace.square.ts"
			}
		},
		end: "\\]",
		endCaptures: {
			"0": {
				name: "meta.array.literal.ts meta.brace.square.ts"
			}
		},
		patterns: [
			{
				include: "#style"
			}
		]
	},
	style: {
		begin: "\\s*([`|'|\"])",
		beginCaptures: {
			"1": {
				name: "string"
			}
		},
		end: "\\1",
		endCaptures: {
			"0": {
				name: "string"
			}
		},
		contentName: "source.css",
		patterns: [
			{
				include: "source.css"
			}
		]
	}
};
var information_for_contributors = [
	"This file has been converted from https://github.com/angular/vscode-ng-language-service/blob/master/",
	"If you want to provide a fix or improvement, please create a pull request against the original repository.",
	"Once accepted there, we are happy to receive an update request."
];
var inlineStyles = {
	scopeName: scopeName,
	injectionSelector: injectionSelector,
	patterns: patterns,
	repository: repository,
	information_for_contributors: information_for_contributors
};

export { inlineStyles as default, information_for_contributors, injectionSelector, patterns, repository, scopeName };
