var scopeName = "inline-template.ng";
var injectionSelector = "L:meta.decorator.ts -comment -text.html";
var patterns = [
	{
		include: "#inlineTemplate"
	}
];
var repository = {
	inlineTemplate: {
		begin: "(template)\\s*(:)",
		beginCaptures: {
			"1": {
				name: "meta.object-literal.key.ts"
			},
			"2": {
				name: "meta.object-literal.key.ts punctuation.separator.key-value.ts"
			}
		},
		end: "(?=,|})",
		patterns: [
			{
				include: "#tsParenExpression"
			},
			{
				include: "#ngTemplate"
			}
		]
	},
	tsParenExpression: {
		begin: "\\G\\s*(\\()",
		beginCaptures: {
			"1": {
				name: "meta.brace.round.ts"
			}
		},
		end: "\\)",
		endCaptures: {
			"0": {
				name: "meta.brace.round.ts"
			}
		},
		patterns: [
			{
				include: "#tsParenExpression"
			},
			{
				include: "#ngTemplate"
			}
		]
	},
	ngTemplate: {
		begin: "\\G\\s*([`|'|\"])",
		beginCaptures: {
			"1": {
				name: "string"
			}
		},
		end: "\\1",
		endCaptures: {
			"0": {
				name: "string"
			}
		},
		contentName: "text.html",
		patterns: [
			{
				include: "text.html.derivative"
			},
			{
				include: "template.ng"
			}
		]
	}
};
var information_for_contributors = [
	"This file has been converted from https://github.com/angular/vscode-ng-language-service/blob/master/",
	"If you want to provide a fix or improvement, please create a pull request against the original repository.",
	"Once accepted there, we are happy to receive an update request."
];
var inlineTemplate = {
	scopeName: scopeName,
	injectionSelector: injectionSelector,
	patterns: patterns,
	repository: repository,
	information_for_contributors: information_for_contributors
};

export { inlineTemplate as default, information_for_contributors, injectionSelector, patterns, repository, scopeName };
