var comments = {
	lineComment: "//",
	blockComment: [
		"/*",
		"*/"
	]
};
var brackets = [
	[
		"{",
		"}"
	],
	[
		"[",
		"]"
	]
];
var autoClosingPairs = [
	{
		open: "{",
		close: "}",
		notIn: [
			"string"
		]
	},
	{
		open: "[",
		close: "]",
		notIn: [
			"string"
		]
	},
	{
		open: "(",
		close: ")",
		notIn: [
			"string"
		]
	},
	{
		open: "'",
		close: "'",
		notIn: [
			"string"
		]
	},
	{
		open: "\"",
		close: "\"",
		notIn: [
			"string",
			"comment"
		]
	},
	{
		open: "`",
		close: "`",
		notIn: [
			"string",
			"comment"
		]
	}
];
var indentationRules = {
	increaseIndentPattern: "({+(?=((\\\\.|[^\"\\\\])*\"(\\\\.|[^\"\\\\])*\")*[^\"}]*)$)|(\\[+(?=((\\\\.|[^\"\\\\])*\"(\\\\.|[^\"\\\\])*\")*[^\"\\]]*)$)",
	decreaseIndentPattern: "^\\s*[}\\]],?\\s*$"
};
var json = {
	comments: comments,
	brackets: brackets,
	autoClosingPairs: autoClosingPairs,
	indentationRules: indentationRules
};

export { autoClosingPairs, brackets, comments, json as default, indentationRules };
