var comments = {
	blockComment: [
		"{/*",
		"*/}"
	]
};
var brackets = [
	[
		"{",
		"}"
	],
	[
		"[",
		"]"
	],
	[
		"(",
		")"
	],
	[
		"<",
		">"
	]
];
var colorizedBracketPairs = [
	[
		"{",
		"}"
	],
	[
		"[",
		"]"
	],
	[
		"(",
		")"
	]
];
var autoClosingPairs = [
	{
		open: "{",
		close: "}"
	},
	{
		open: "[",
		close: "]"
	},
	{
		open: "(",
		close: ")"
	},
	{
		open: "'",
		close: "'",
		notIn: [
			"string",
			"comment"
		]
	},
	{
		open: "\"",
		close: "\"",
		notIn: [
			"string"
		]
	},
	{
		open: "/**",
		close: " */",
		notIn: [
			"string"
		]
	}
];
var surroundingPairs = [
	[
		"{",
		"}"
	],
	[
		"[",
		"]"
	],
	[
		"(",
		")"
	],
	[
		"<",
		">"
	],
	[
		"'",
		"'"
	],
	[
		"\"",
		"\""
	]
];
var wordPattern = {
	pattern: "(-?\\d*\\.\\d\\w*)|([^\\`\\~\\!\\@\\$\\^\\&\\*\\(\\)\\=\\+\\[\\{\\]\\}\\\\\\|\\;\\:'\"\\,\\.\\<\\>\\/\\s]+)"
};
var onEnterRules = [
	{
		beforeText: {
			pattern: "<(?!(?:area|base|br|col|embed|hr|img|input|keygen|link|menuitem|meta|param|source|track|wbr))([_:\\w][_:\\w\\-.\\d]*)([^/>]*(?!/)>)[^<]*$",
			flags: "i"
		},
		afterText: {
			pattern: "^<\\/([_:\\w][_:\\w-.\\d]*)\\s*>$",
			flags: "i"
		},
		action: {
			indent: "indentOutdent"
		}
	},
	{
		beforeText: {
			pattern: "<(?!(?:area|base|br|col|embed|hr|img|input|keygen|link|menuitem|meta|param|source|track|wbr))([_:\\w][_:\\w\\-.\\d]*)([^/>]*(?!/)>)[^<]*$",
			flags: "i"
		},
		action: {
			indent: "indent"
		}
	},
	{
		beforeText: {
			pattern: "^>$"
		},
		afterText: {
			pattern: "^<\\/([_:\\w][_:\\w-.\\d]*)\\s*>$",
			flags: "i"
		},
		action: {
			indent: "indentOutdent"
		}
	},
	{
		beforeText: {
			pattern: "^>$"
		},
		action: {
			indent: "indent"
		}
	}
];
var jsxTags = {
	comments: comments,
	brackets: brackets,
	colorizedBracketPairs: colorizedBracketPairs,
	autoClosingPairs: autoClosingPairs,
	surroundingPairs: surroundingPairs,
	wordPattern: wordPattern,
	onEnterRules: onEnterRules
};

export { autoClosingPairs, brackets, colorizedBracketPairs, comments, jsxTags as default, onEnterRules, surroundingPairs, wordPattern };
