var fileTypes = [
	"lhs"
];
var keyEquivalent = "^~H";
var name = "Literate Haskell";
var patterns = [
	{
		begin: "^((\\\\)begin)({)code(})(\\s*\\n)?",
		captures: {
			"1": {
				name: "support.function.be.latex"
			},
			"2": {
				name: "punctuation.definition.function.latex"
			},
			"3": {
				name: "punctuation.definition.arguments.begin.latex"
			},
			"4": {
				name: "punctuation.definition.arguments.end.latex"
			}
		},
		contentName: "source.haskell.embedded.latex",
		end: "^((\\\\)end)({)code(})",
		name: "meta.embedded.block.haskell.latex",
		patterns: [
			{
				include: "source.haskell"
			}
		]
	},
	{
		begin: "^(> )",
		beginCaptures: {
			"1": {
				name: "punctuation.definition.bird-track.haskell"
			}
		},
		comment: "This breaks type signature detection for now, but it's better than having no highlighting whatsoever.",
		contentName: "source.haskell",
		end: "$",
		name: "meta.embedded.haskell",
		patterns: [
			{
				include: "source.haskell"
			}
		]
	},
	{
		include: "text.tex.latex"
	}
];
var scopeName = "text.tex.latex.haskell";
var uuid = "439807F5-7129-487D-B5DC-95D5272B43DD";
var information_for_contributors = [
	"This file has been converted from https://github.com/JustusAdam/language-haskell/blob/df29e5733bd5b31c59af7404306e0759431c33ea/",
	"If you want to provide a fix or improvement, please create a pull request against the original repository.",
	"Once accepted there, we are happy to receive an update request."
];
var literateHaskell_tmLanguage = {
	fileTypes: fileTypes,
	keyEquivalent: keyEquivalent,
	name: name,
	patterns: patterns,
	scopeName: scopeName,
	uuid: uuid,
	information_for_contributors: information_for_contributors
};

export { literateHaskell_tmLanguage as default, fileTypes, information_for_contributors, keyEquivalent, name, patterns, scopeName, uuid };
