var lua = [
  {
    "properties": {
      "Lua.completion.autoRequire": {
        "default": true,
        "markdownDescription": "When the input looks like a file name, automatically `require` this file.",
        "scope": 4,
        "type": "boolean"
      },
      "Lua.completion.callSnippet": {
        "default": "Disable",
        "enum": [
          "Disable",
          "Both",
          "Replace"
        ],
        "markdownDescription": "Shows function call snippets.",
        "markdownEnumDescriptions": [
          "Only shows `function name`.",
          "Shows `function name` and `call snippet`.",
          "Only shows `call snippet.`"
        ],
        "scope": 4,
        "type": "string"
      },
      "Lua.completion.displayContext": {
        "default": 0,
        "markdownDescription": "Previewing the relevant code snippet of the suggestion may help you understand the usage of the suggestion. The number set indicates the number of intercepted lines in the code fragment. If it is set to `0`, this feature can be disabled.",
        "scope": 4,
        "type": "integer"
      },
      "Lua.completion.enable": {
        "default": true,
        "markdownDescription": "Enable completion.",
        "scope": 4,
        "type": "boolean"
      },
      "Lua.completion.keywordSnippet": {
        "default": "Replace",
        "enum": [
          "Disable",
          "Both",
          "Replace"
        ],
        "markdownDescription": "Shows keyword syntax snippets.",
        "markdownEnumDescriptions": [
          "Only shows `keyword`.",
          "Shows `keyword` and `syntax snippet`.",
          "Only shows `syntax snippet`."
        ],
        "scope": 4,
        "type": "string"
      },
      "Lua.completion.postfix": {
        "default": "@",
        "markdownDescription": "The symbol used to trigger the postfix suggestion.",
        "scope": 4,
        "type": "string"
      },
      "Lua.completion.requireSeparator": {
        "default": ".",
        "markdownDescription": "The separator used when `require`.",
        "scope": 4,
        "type": "string"
      },
      "Lua.completion.showParams": {
        "default": true,
        "markdownDescription": "Display parameters in completion list. When the function has multiple definitions, they will be displayed separately.",
        "scope": 4,
        "type": "boolean"
      },
      "Lua.completion.showWord": {
        "default": "Fallback",
        "enum": [
          "Enable",
          "Fallback",
          "Disable"
        ],
        "markdownDescription": "Show contextual words in suggestions.",
        "markdownEnumDescriptions": [
          "Always show context words in suggestions.",
          "Contextual words are only displayed when suggestions based on semantics cannot be provided.",
          "Do not display context words."
        ],
        "scope": 4,
        "type": "string"
      },
      "Lua.completion.workspaceWord": {
        "default": true,
        "markdownDescription": "Whether the displayed context word contains the content of other files in the workspace.",
        "scope": 4,
        "type": "boolean"
      },
      "Lua.diagnostics.disable": {
        "default": [
          "lowercase-global"
        ],
        "items": {
          "enum": [
            "action-after-return",
            "ambiguity-1",
            "ambiguous-syntax",
            "args-after-dots",
            "assign-type-mismatch",
            "await-in-sync",
            "block-after-else",
            "break-outside",
            "cast-local-type",
            "cast-type-mismatch",
            "circle-doc-class",
            "close-non-object",
            "code-after-break",
            "codestyle-check",
            "count-down-loop",
            "deprecated",
            "different-requires",
            "discard-returns",
            "doc-field-no-class",
            "duplicate-doc-alias",
            "duplicate-doc-field",
            "duplicate-doc-param",
            "duplicate-index",
            "duplicate-set-field",
            "empty-block",
            "err-assign-as-eq",
            "err-c-long-comment",
            "err-comment-prefix",
            "err-do-as-then",
            "err-eq-as-assign",
            "err-esc",
            "err-nonstandard-symbol",
            "err-then-as-do",
            "exp-in-action",
            "global-in-nil-env",
            "index-in-func-name",
            "jump-local-scope",
            "keyword",
            "local-limit",
            "lowercase-global",
            "lua-doc-miss-sign",
            "luadoc-error-diag-mode",
            "luadoc-miss-alias-extends",
            "luadoc-miss-alias-name",
            "luadoc-miss-arg-name",
            "luadoc-miss-cate-name",
            "luadoc-miss-class-extends-name",
            "luadoc-miss-class-name",
            "luadoc-miss-diag-mode",
            "luadoc-miss-diag-name",
            "luadoc-miss-field-extends",
            "luadoc-miss-field-name",
            "luadoc-miss-fun-after-overload",
            "luadoc-miss-generic-name",
            "luadoc-miss-local-name",
            "luadoc-miss-module-name",
            "luadoc-miss-operator-name",
            "luadoc-miss-param-extends",
            "luadoc-miss-param-name",
            "luadoc-miss-sign-name",
            "luadoc-miss-symbol",
            "luadoc-miss-type-name",
            "luadoc-miss-vararg-type",
            "luadoc-miss-version",
            "malformed-number",
            "miss-end",
            "miss-esc-x",
            "miss-exp",
            "miss-exponent",
            "miss-field",
            "miss-loop-max",
            "miss-loop-min",
            "miss-method",
            "miss-name",
            "miss-sep-in-table",
            "miss-space-between",
            "miss-symbol",
            "missing-parameter",
            "missing-return",
            "missing-return-value",
            "need-check-nil",
            "need-paren",
            "newfield-call",
            "newline-call",
            "no-unknown",
            "no-visible-label",
            "not-yieldable",
            "param-type-mismatch",
            "redefined-label",
            "redefined-local",
            "redundant-parameter",
            "redundant-return",
            "redundant-return-value",
            "redundant-value",
            "return-type-mismatch",
            "set-const",
            "spell-check",
            "trailing-space",
            "unbalanced-assignments",
            "undefined-doc-class",
            "undefined-doc-name",
            "undefined-doc-param",
            "undefined-env-child",
            "undefined-field",
            "undefined-global",
            "unexpect-dots",
            "unexpect-efunc-name",
            "unexpect-lfunc-name",
            "unexpect-symbol",
            "unicode-name",
            "unknown-attribute",
            "unknown-cast-variable",
            "unknown-diag-code",
            "unknown-operator",
            "unknown-symbol",
            "unreachable-code",
            "unsupport-symbol",
            "unused-function",
            "unused-label",
            "unused-local",
            "unused-vararg"
          ],
          "type": "string"
        },
        "markdownDescription": "Disabled diagnostic (Use code in hover brackets).",
        "scope": 4,
        "type": "array"
      },
      "Lua.diagnostics.disableScheme": {
        "default": [
          "git"
        ],
        "items": {
          "type": "string"
        },
        "markdownDescription": "Do not diagnose Lua files that use the following scheme.",
        "scope": 4,
        "type": "array"
      },
      "Lua.diagnostics.enable": {
        "default": true,
        "markdownDescription": "Enable diagnostics.",
        "scope": 4,
        "type": "boolean"
      },
      "Lua.diagnostics.globals": {
        "default": [],
        "items": {
          "type": "string"
        },
        "markdownDescription": "Defined global variables.",
        "scope": 4,
        "type": "array"
      },
      "Lua.diagnostics.groupFileStatus": {
        "additionalProperties": false,
        "markdownDescription": "Modify the diagnostic needed file status in a group.\n\n* Opened:  only diagnose opened files\n* Any:     diagnose all files\n* None:    disable this diagnostic\n\n`Fallback` means that diagnostics in this group are controlled by `diagnostics.neededFileStatus` separately.\nOther settings will override individual settings without end of `!`.\n",
        "properties": {
          "ambiguity": {
            "default": "Fallback",
            "description": "* ambiguity-1\n* count-down-loop\n* different-requires\n* newfield-call\n* newline-call",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Fallback"
            ],
            "type": "string"
          },
          "await": {
            "default": "Fallback",
            "description": "* await-in-sync\n* not-yieldable",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Fallback"
            ],
            "type": "string"
          },
          "codestyle": {
            "default": "Fallback",
            "description": "* codestyle-check\n* spell-check",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Fallback"
            ],
            "type": "string"
          },
          "duplicate": {
            "default": "Fallback",
            "description": "* duplicate-index\n* duplicate-set-field",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Fallback"
            ],
            "type": "string"
          },
          "global": {
            "default": "Fallback",
            "description": "* global-in-nil-env\n* lowercase-global\n* undefined-env-child\n* undefined-global",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Fallback"
            ],
            "type": "string"
          },
          "luadoc": {
            "default": "Fallback",
            "description": "* circle-doc-class\n* doc-field-no-class\n* duplicate-doc-alias\n* duplicate-doc-field\n* duplicate-doc-param\n* undefined-doc-class\n* undefined-doc-name\n* undefined-doc-param\n* unknown-cast-variable\n* unknown-diag-code\n* unknown-operator",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Fallback"
            ],
            "type": "string"
          },
          "redefined": {
            "default": "Fallback",
            "description": "* redefined-local",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Fallback"
            ],
            "type": "string"
          },
          "strict": {
            "default": "Fallback",
            "description": "* close-non-object\n* deprecated\n* discard-returns",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Fallback"
            ],
            "type": "string"
          },
          "strong": {
            "default": "Fallback",
            "description": "* no-unknown",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Fallback"
            ],
            "type": "string"
          },
          "type-check": {
            "default": "Fallback",
            "description": "* assign-type-mismatch\n* cast-local-type\n* cast-type-mismatch\n* need-check-nil\n* param-type-mismatch\n* return-type-mismatch\n* undefined-field",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Fallback"
            ],
            "type": "string"
          },
          "unbalanced": {
            "default": "Fallback",
            "description": "* missing-parameter\n* missing-return\n* missing-return-value\n* redundant-parameter\n* redundant-return-value\n* redundant-value\n* unbalanced-assignments",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Fallback"
            ],
            "type": "string"
          },
          "unused": {
            "default": "Fallback",
            "description": "* code-after-break\n* empty-block\n* redundant-return\n* trailing-space\n* unreachable-code\n* unused-function\n* unused-label\n* unused-local\n* unused-vararg",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Fallback"
            ],
            "type": "string"
          }
        },
        "scope": 4,
        "title": "groupFileStatus",
        "type": "object"
      },
      "Lua.diagnostics.groupSeverity": {
        "additionalProperties": false,
        "markdownDescription": "Modify the diagnostic severity in a group.\n`Fallback` means that diagnostics in this group are controlled by `diagnostics.severity` separately.\nOther settings will override individual settings without end of `!`.\n",
        "properties": {
          "ambiguity": {
            "default": "Fallback",
            "description": "* ambiguity-1\n* count-down-loop\n* different-requires\n* newfield-call\n* newline-call",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Fallback"
            ],
            "type": "string"
          },
          "await": {
            "default": "Fallback",
            "description": "* await-in-sync\n* not-yieldable",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Fallback"
            ],
            "type": "string"
          },
          "codestyle": {
            "default": "Fallback",
            "description": "* codestyle-check\n* spell-check",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Fallback"
            ],
            "type": "string"
          },
          "duplicate": {
            "default": "Fallback",
            "description": "* duplicate-index\n* duplicate-set-field",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Fallback"
            ],
            "type": "string"
          },
          "global": {
            "default": "Fallback",
            "description": "* global-in-nil-env\n* lowercase-global\n* undefined-env-child\n* undefined-global",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Fallback"
            ],
            "type": "string"
          },
          "luadoc": {
            "default": "Fallback",
            "description": "* circle-doc-class\n* doc-field-no-class\n* duplicate-doc-alias\n* duplicate-doc-field\n* duplicate-doc-param\n* undefined-doc-class\n* undefined-doc-name\n* undefined-doc-param\n* unknown-cast-variable\n* unknown-diag-code\n* unknown-operator",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Fallback"
            ],
            "type": "string"
          },
          "redefined": {
            "default": "Fallback",
            "description": "* redefined-local",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Fallback"
            ],
            "type": "string"
          },
          "strict": {
            "default": "Fallback",
            "description": "* close-non-object\n* deprecated\n* discard-returns",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Fallback"
            ],
            "type": "string"
          },
          "strong": {
            "default": "Fallback",
            "description": "* no-unknown",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Fallback"
            ],
            "type": "string"
          },
          "type-check": {
            "default": "Fallback",
            "description": "* assign-type-mismatch\n* cast-local-type\n* cast-type-mismatch\n* need-check-nil\n* param-type-mismatch\n* return-type-mismatch\n* undefined-field",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Fallback"
            ],
            "type": "string"
          },
          "unbalanced": {
            "default": "Fallback",
            "description": "* missing-parameter\n* missing-return\n* missing-return-value\n* redundant-parameter\n* redundant-return-value\n* redundant-value\n* unbalanced-assignments",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Fallback"
            ],
            "type": "string"
          },
          "unused": {
            "default": "Fallback",
            "description": "* code-after-break\n* empty-block\n* redundant-return\n* trailing-space\n* unreachable-code\n* unused-function\n* unused-label\n* unused-local\n* unused-vararg",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Fallback"
            ],
            "type": "string"
          }
        },
        "scope": 4,
        "title": "groupSeverity",
        "type": "object"
      },
      "Lua.diagnostics.ignoredFiles": {
        "default": "Opened",
        "enum": [
          "Enable",
          "Opened",
          "Disable"
        ],
        "markdownDescription": "How to diagnose ignored files.",
        "markdownEnumDescriptions": [
          "Always diagnose these files.",
          "Only when these files are opened will it be diagnosed.",
          "These files are not diagnosed."
        ],
        "scope": 4,
        "type": "string"
      },
      "Lua.diagnostics.libraryFiles": {
        "default": "Opened",
        "enum": [
          "Enable",
          "Opened",
          "Disable"
        ],
        "markdownDescription": "How to diagnose files loaded via `Lua.workspace.library`.",
        "markdownEnumDescriptions": [
          "Always diagnose these files.",
          "Only when these files are opened will it be diagnosed.",
          "These files are not diagnosed."
        ],
        "scope": 4,
        "type": "string"
      },
      "Lua.diagnostics.neededFileStatus": {
        "additionalProperties": false,
        "markdownDescription": "* Opened:  only diagnose opened files\n* Any:     diagnose all files\n* None:    disable this diagnostic\n\nEnd with `!` means override the group setting `diagnostics.groupFileStatus`.\n",
        "properties": {
          "ambiguity-1": {
            "default": "Any",
            "description": "Enable ambiguous operator precedence diagnostics. For example, the `num or 0 + 1` expression will be suggested `(num or 0) + 1` instead.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "assign-type-mismatch": {
            "default": "Opened",
            "description": "Enable diagnostics for assignments in which the value's type does not match the type of the assigned variable.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "await-in-sync": {
            "default": "None",
            "description": "Enable diagnostics for calls of asynchronous functions within a synchronous function.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "cast-local-type": {
            "default": "Opened",
            "description": "Enable diagnostics for casts of local variables where the target type does not match the defined type.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "cast-type-mismatch": {
            "default": "Opened",
            "description": "Enable diagnostics for casts where the target type does not match the initial type.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "circle-doc-class": {
            "default": "Any",
            "description": "%config.diagnostics.circle-doc-class%",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "close-non-object": {
            "default": "Any",
            "description": "Enable diagnostics for attempts to close a variable with a non-object.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "code-after-break": {
            "default": "Opened",
            "description": "Enable diagnostics for code placed after a break statement in a loop.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "codestyle-check": {
            "default": "None",
            "description": "Enable diagnostics for incorrectly styled lines.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "count-down-loop": {
            "default": "Any",
            "description": "Enable diagnostics for `for` loops which will never reach their max/limit because the loop is incrementing instead of decrementing.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "deprecated": {
            "default": "Any",
            "description": "Enable diagnostics to highlight deprecated API.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "different-requires": {
            "default": "Any",
            "description": "Enable diagnostics for files which are required by two different paths.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "discard-returns": {
            "default": "Any",
            "description": "Enable diagnostics for calls of functions annotated with `---@nodiscard` where the return values are ignored.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "doc-field-no-class": {
            "default": "Any",
            "description": "Enable diagnostics to highlight a field annotation without a defining class annotation.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "duplicate-doc-alias": {
            "default": "Any",
            "description": "Enable diagnostics for a duplicated alias annotation name.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "duplicate-doc-field": {
            "default": "Any",
            "description": "Enable diagnostics for a duplicated field annotation name.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "duplicate-doc-param": {
            "default": "Any",
            "description": "Enable diagnostics for a duplicated param annotation name.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "duplicate-index": {
            "default": "Any",
            "description": "Enable duplicate table index diagnostics.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "duplicate-set-field": {
            "default": "Any",
            "description": "Enable diagnostics for setting the same field in a class more than once.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "empty-block": {
            "default": "Opened",
            "description": "Enable empty code block diagnostics.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "global-in-nil-env": {
            "default": "Any",
            "description": "Enable cannot use global variables （ `_ENV` is set to `nil`） diagnostics.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "lowercase-global": {
            "default": "Any",
            "description": "Enable lowercase global variable definition diagnostics.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "missing-parameter": {
            "default": "Any",
            "description": "Enable diagnostics for function calls where the number of arguments is less than the number of annotated function parameters.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "missing-return": {
            "default": "Any",
            "description": "Enable diagnostics for functions with return annotations which have no return statement.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "missing-return-value": {
            "default": "Any",
            "description": "Enable diagnostics for return statements without values although the containing function declares returns.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "need-check-nil": {
            "default": "Opened",
            "description": "Enable diagnostics for variable usages if `nil` or an optional (potentially `nil`) value was assigned to the variable before.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "newfield-call": {
            "default": "Any",
            "description": "Enable newfield call diagnostics. It is raised when the parenthesis of a function call appear on the following line when defining a field in a table.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "newline-call": {
            "default": "Any",
            "description": "Enable newline call diagnostics. Is's raised when a line starting with `(` is encountered, which is syntactically parsed as a function call on the previous line.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "no-unknown": {
            "default": "None",
            "description": "Enable diagnostics for cases in which the type cannot be inferred.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "not-yieldable": {
            "default": "None",
            "description": "Enable diagnostics for calls to `coroutine.yield()` when it is not permitted.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "param-type-mismatch": {
            "default": "Opened",
            "description": "Enable diagnostics for function calls where the type of a provided parameter does not match the type of the annotated function definition.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "redefined-local": {
            "default": "Opened",
            "description": "Enable redefined local variable diagnostics.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "redundant-parameter": {
            "default": "Any",
            "description": "Enable redundant function parameter diagnostics.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "redundant-return": {
            "default": "Opened",
            "description": "Enable diagnostics for return statements which are not needed because the function would exit on its own.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "redundant-return-value": {
            "default": "Any",
            "description": "Enable diagnostics for return statements which return an extra value which is not specified by a return annotation.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "redundant-value": {
            "default": "Any",
            "description": "Enable the redundant values assigned diagnostics. It's raised during assignment operation, when the number of values is higher than the number of objects being assigned.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "return-type-mismatch": {
            "default": "Opened",
            "description": "Enable diagnostics for return values whose type does not match the type declared in the corresponding return annotation.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "spell-check": {
            "default": "None",
            "description": "Enable diagnostics for typos in strings.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "trailing-space": {
            "default": "Opened",
            "description": "Enable trailing space diagnostics.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "unbalanced-assignments": {
            "default": "Any",
            "description": "Enable diagnostics on multiple assignments if not all variables obtain a value (e.g., `local x,y = 1`).",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "undefined-doc-class": {
            "default": "Any",
            "description": "Enable diagnostics for class annotations in which an undefined class is referenced.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "undefined-doc-name": {
            "default": "Any",
            "description": "Enable diagnostics for type annotations referencing an undefined type or alias.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "undefined-doc-param": {
            "default": "Any",
            "description": "Enable diagnostics for cases in which a parameter annotation is given without declaring the parameter in the function definition.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "undefined-env-child": {
            "default": "Any",
            "description": "Enable undefined environment variable diagnostics. It's raised when `_ENV` table is set to a new literal table, but the used global variable is no longer present in the global environment.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "undefined-field": {
            "default": "Opened",
            "description": "Enable diagnostics for cases in which an undefined field of a variable is read.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "undefined-global": {
            "default": "Any",
            "description": "Enable undefined global variable diagnostics.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "unknown-cast-variable": {
            "default": "Any",
            "description": "Enable diagnostics for casts of undefined variables.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "unknown-diag-code": {
            "default": "Any",
            "description": "Enable diagnostics in cases in which an unknown diagnostics code is entered.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "unknown-operator": {
            "default": "Any",
            "description": "Enable diagnostics for unknown operators.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "unreachable-code": {
            "default": "Opened",
            "description": "Enable diagnostics for unreachable code.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "unused-function": {
            "default": "Opened",
            "description": "Enable unused function diagnostics.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "unused-label": {
            "default": "Opened",
            "description": "Enable unused label diagnostics.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "unused-local": {
            "default": "Opened",
            "description": "Enable unused local variable diagnostics.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          },
          "unused-vararg": {
            "default": "Opened",
            "description": "Enable unused vararg diagnostics.",
            "enum": [
              "Any",
              "Opened",
              "None",
              "Any!",
              "Opened!",
              "None!"
            ],
            "type": "string"
          }
        },
        "scope": 4,
        "title": "neededFileStatus",
        "type": "object"
      },
      "Lua.diagnostics.severity": {
        "additionalProperties": false,
        "markdownDescription": "Modify the diagnostic severity.\n\nEnd with `!` means override the group setting `diagnostics.groupSeverity`.\n",
        "properties": {
          "ambiguity-1": {
            "default": "Warning",
            "description": "Enable ambiguous operator precedence diagnostics. For example, the `num or 0 + 1` expression will be suggested `(num or 0) + 1` instead.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "assign-type-mismatch": {
            "default": "Warning",
            "description": "Enable diagnostics for assignments in which the value's type does not match the type of the assigned variable.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "await-in-sync": {
            "default": "Warning",
            "description": "Enable diagnostics for calls of asynchronous functions within a synchronous function.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "cast-local-type": {
            "default": "Warning",
            "description": "Enable diagnostics for casts of local variables where the target type does not match the defined type.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "cast-type-mismatch": {
            "default": "Warning",
            "description": "Enable diagnostics for casts where the target type does not match the initial type.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "circle-doc-class": {
            "default": "Warning",
            "description": "%config.diagnostics.circle-doc-class%",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "close-non-object": {
            "default": "Warning",
            "description": "Enable diagnostics for attempts to close a variable with a non-object.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "code-after-break": {
            "default": "Hint",
            "description": "Enable diagnostics for code placed after a break statement in a loop.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "codestyle-check": {
            "default": "Warning",
            "description": "Enable diagnostics for incorrectly styled lines.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "count-down-loop": {
            "default": "Warning",
            "description": "Enable diagnostics for `for` loops which will never reach their max/limit because the loop is incrementing instead of decrementing.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "deprecated": {
            "default": "Warning",
            "description": "Enable diagnostics to highlight deprecated API.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "different-requires": {
            "default": "Warning",
            "description": "Enable diagnostics for files which are required by two different paths.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "discard-returns": {
            "default": "Warning",
            "description": "Enable diagnostics for calls of functions annotated with `---@nodiscard` where the return values are ignored.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "doc-field-no-class": {
            "default": "Warning",
            "description": "Enable diagnostics to highlight a field annotation without a defining class annotation.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "duplicate-doc-alias": {
            "default": "Warning",
            "description": "Enable diagnostics for a duplicated alias annotation name.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "duplicate-doc-field": {
            "default": "Warning",
            "description": "Enable diagnostics for a duplicated field annotation name.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "duplicate-doc-param": {
            "default": "Warning",
            "description": "Enable diagnostics for a duplicated param annotation name.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "duplicate-index": {
            "default": "Warning",
            "description": "Enable duplicate table index diagnostics.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "duplicate-set-field": {
            "default": "Warning",
            "description": "Enable diagnostics for setting the same field in a class more than once.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "empty-block": {
            "default": "Hint",
            "description": "Enable empty code block diagnostics.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "global-in-nil-env": {
            "default": "Warning",
            "description": "Enable cannot use global variables （ `_ENV` is set to `nil`） diagnostics.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "lowercase-global": {
            "default": "Information",
            "description": "Enable lowercase global variable definition diagnostics.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "missing-parameter": {
            "default": "Warning",
            "description": "Enable diagnostics for function calls where the number of arguments is less than the number of annotated function parameters.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "missing-return": {
            "default": "Warning",
            "description": "Enable diagnostics for functions with return annotations which have no return statement.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "missing-return-value": {
            "default": "Warning",
            "description": "Enable diagnostics for return statements without values although the containing function declares returns.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "need-check-nil": {
            "default": "Warning",
            "description": "Enable diagnostics for variable usages if `nil` or an optional (potentially `nil`) value was assigned to the variable before.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "newfield-call": {
            "default": "Warning",
            "description": "Enable newfield call diagnostics. It is raised when the parenthesis of a function call appear on the following line when defining a field in a table.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "newline-call": {
            "default": "Warning",
            "description": "Enable newline call diagnostics. Is's raised when a line starting with `(` is encountered, which is syntactically parsed as a function call on the previous line.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "no-unknown": {
            "default": "Warning",
            "description": "Enable diagnostics for cases in which the type cannot be inferred.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "not-yieldable": {
            "default": "Warning",
            "description": "Enable diagnostics for calls to `coroutine.yield()` when it is not permitted.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "param-type-mismatch": {
            "default": "Warning",
            "description": "Enable diagnostics for function calls where the type of a provided parameter does not match the type of the annotated function definition.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "redefined-local": {
            "default": "Hint",
            "description": "Enable redefined local variable diagnostics.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "redundant-parameter": {
            "default": "Warning",
            "description": "Enable redundant function parameter diagnostics.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "redundant-return": {
            "default": "Hint",
            "description": "Enable diagnostics for return statements which are not needed because the function would exit on its own.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "redundant-return-value": {
            "default": "Warning",
            "description": "Enable diagnostics for return statements which return an extra value which is not specified by a return annotation.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "redundant-value": {
            "default": "Warning",
            "description": "Enable the redundant values assigned diagnostics. It's raised during assignment operation, when the number of values is higher than the number of objects being assigned.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "return-type-mismatch": {
            "default": "Warning",
            "description": "Enable diagnostics for return values whose type does not match the type declared in the corresponding return annotation.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "spell-check": {
            "default": "Information",
            "description": "Enable diagnostics for typos in strings.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "trailing-space": {
            "default": "Hint",
            "description": "Enable trailing space diagnostics.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "unbalanced-assignments": {
            "default": "Warning",
            "description": "Enable diagnostics on multiple assignments if not all variables obtain a value (e.g., `local x,y = 1`).",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "undefined-doc-class": {
            "default": "Warning",
            "description": "Enable diagnostics for class annotations in which an undefined class is referenced.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "undefined-doc-name": {
            "default": "Warning",
            "description": "Enable diagnostics for type annotations referencing an undefined type or alias.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "undefined-doc-param": {
            "default": "Warning",
            "description": "Enable diagnostics for cases in which a parameter annotation is given without declaring the parameter in the function definition.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "undefined-env-child": {
            "default": "Information",
            "description": "Enable undefined environment variable diagnostics. It's raised when `_ENV` table is set to a new literal table, but the used global variable is no longer present in the global environment.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "undefined-field": {
            "default": "Warning",
            "description": "Enable diagnostics for cases in which an undefined field of a variable is read.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "undefined-global": {
            "default": "Warning",
            "description": "Enable undefined global variable diagnostics.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "unknown-cast-variable": {
            "default": "Warning",
            "description": "Enable diagnostics for casts of undefined variables.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "unknown-diag-code": {
            "default": "Warning",
            "description": "Enable diagnostics in cases in which an unknown diagnostics code is entered.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "unknown-operator": {
            "default": "Warning",
            "description": "Enable diagnostics for unknown operators.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "unreachable-code": {
            "default": "Hint",
            "description": "Enable diagnostics for unreachable code.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "unused-function": {
            "default": "Hint",
            "description": "Enable unused function diagnostics.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "unused-label": {
            "default": "Hint",
            "description": "Enable unused label diagnostics.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "unused-local": {
            "default": "Hint",
            "description": "Enable unused local variable diagnostics.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          },
          "unused-vararg": {
            "default": "Hint",
            "description": "Enable unused vararg diagnostics.",
            "enum": [
              "Error",
              "Warning",
              "Information",
              "Hint",
              "Error!",
              "Warning!",
              "Information!",
              "Hint!"
            ],
            "type": "string"
          }
        },
        "scope": 4,
        "title": "severity",
        "type": "object"
      },
      "Lua.diagnostics.unusedLocalExclude": {
        "default": [],
        "items": {
          "type": "string"
        },
        "markdownDescription": "Do not diagnose `unused-local` when the variable name matches the following pattern.",
        "scope": 4,
        "type": "array"
      },
      "Lua.diagnostics.workspaceDelay": {
        "default": 3000,
        "markdownDescription": "Latency (milliseconds) for workspace diagnostics. When you start the workspace, or edit any file, the entire workspace will be re-diagnosed in the background. Set to negative to disable workspace diagnostics.",
        "scope": 4,
        "type": "integer"
      },
      "Lua.diagnostics.workspaceRate": {
        "default": 100,
        "markdownDescription": "Workspace diagnostics run rate (%). Decreasing this value reduces CPU usage, but also reduces the speed of workspace diagnostics. The diagnosis of the file you are currently editing is always done at full speed and is not affected by this setting.",
        "scope": 4,
        "type": "integer"
      },
      "Lua.format.defaultConfig": {
        "additionalProperties": false,
        "default": {},
        "markdownDescription": "The default format configuration. Has a lower priority than `.editorconfig` file in the workspace.\nRead [formatter docs](https://github.com/CppCXY/EmmyLuaCodeStyle/tree/master/docs) to learn usage.\n",
        "patternProperties": {
          ".*": {
            "default": "",
            "type": "string"
          }
        },
        "scope": 4,
        "title": "defaultConfig",
        "type": "object"
      },
      "Lua.format.enable": {
        "default": true,
        "markdownDescription": "Enable code formatter.",
        "scope": 4,
        "type": "boolean"
      },
      "Lua.hint.arrayIndex": {
        "default": "Auto",
        "enum": [
          "Enable",
          "Auto",
          "Disable"
        ],
        "markdownDescription": "Show hints of array index when constructing a table.",
        "markdownEnumDescriptions": [
          "Show hints in all tables.",
          "Show hints only when the table is greater than 3 items, or the table is a mixed table.",
          "Disable hints of array index."
        ],
        "scope": 4,
        "type": "string"
      },
      "Lua.hint.await": {
        "default": true,
        "markdownDescription": "If the called function is marked `---@async`, prompt `await` at the call.",
        "scope": 4,
        "type": "boolean"
      },
      "Lua.hint.enable": {
        "default": false,
        "markdownDescription": "Enable inlay hint.",
        "scope": 4,
        "type": "boolean"
      },
      "Lua.hint.paramName": {
        "default": "All",
        "enum": [
          "All",
          "Literal",
          "Disable"
        ],
        "markdownDescription": "Show hints of parameter name at the function call.",
        "markdownEnumDescriptions": [
          "All types of parameters are shown.",
          "Only literal type parameters are shown.",
          "Disable parameter hints."
        ],
        "scope": 4,
        "type": "string"
      },
      "Lua.hint.paramType": {
        "default": true,
        "markdownDescription": "Show type hints at the parameter of the function.",
        "scope": 4,
        "type": "boolean"
      },
      "Lua.hint.semicolon": {
        "default": "SameLine",
        "enum": [
          "All",
          "SameLine",
          "Disable"
        ],
        "markdownDescription": "If there is no semicolon at the end of the statement, display a virtual semicolon.",
        "markdownEnumDescriptions": [
          "All statements display virtual semicolons.",
          "When two statements are on the same line, display a semicolon between them.",
          "Disable virtual semicolons."
        ],
        "scope": 4,
        "type": "string"
      },
      "Lua.hint.setType": {
        "default": false,
        "markdownDescription": "Show hints of type at assignment operation.",
        "scope": 4,
        "type": "boolean"
      },
      "Lua.hover.enable": {
        "default": true,
        "markdownDescription": "Enable hover.",
        "scope": 4,
        "type": "boolean"
      },
      "Lua.hover.enumsLimit": {
        "default": 5,
        "markdownDescription": "When the value corresponds to multiple types, limit the number of types displaying.",
        "scope": 4,
        "type": "integer"
      },
      "Lua.hover.expandAlias": {
        "default": true,
        "markdownDescription": "Whether to expand the alias. For example, expands `---@alias myType boolean|number` appears as `boolean|number`, otherwise it appears as `myType'.\n",
        "scope": 4,
        "type": "boolean"
      },
      "Lua.hover.previewFields": {
        "default": 50,
        "markdownDescription": "When hovering to view a table, limits the maximum number of previews for fields.",
        "scope": 4,
        "type": "integer"
      },
      "Lua.hover.viewNumber": {
        "default": true,
        "markdownDescription": "Hover to view numeric content (only if literal is not decimal).",
        "scope": 4,
        "type": "boolean"
      },
      "Lua.hover.viewString": {
        "default": true,
        "markdownDescription": "Hover to view the contents of a string (only if the literal contains an escape character).",
        "scope": 4,
        "type": "boolean"
      },
      "Lua.hover.viewStringMax": {
        "default": 1000,
        "markdownDescription": "The maximum length of a hover to view the contents of a string.",
        "scope": 4,
        "type": "integer"
      },
      "Lua.misc.parameters": {
        "default": [],
        "items": {
          "type": "string"
        },
        "markdownDescription": "[Command line parameters](https://github.com/sumneko/lua-telemetry-server/tree/master/method) when starting the language service in VSCode.",
        "scope": 4,
        "type": "array"
      },
      "Lua.runtime.builtin": {
        "additionalProperties": false,
        "markdownDescription": "Adjust the enabled state of the built-in library. You can disable (or redefine) the non-existent library according to the actual runtime environment.\n\n* `default`: Indicates that the library will be enabled or disabled according to the runtime version\n* `enable`: always enable\n* `disable`: always disable\n",
        "properties": {
          "basic": {
            "default": "default",
            "description": "%config.runtime.builtin.basic%",
            "enum": [
              "default",
              "enable",
              "disable"
            ],
            "type": "string"
          },
          "bit": {
            "default": "default",
            "description": "%config.runtime.builtin.bit%",
            "enum": [
              "default",
              "enable",
              "disable"
            ],
            "type": "string"
          },
          "bit32": {
            "default": "default",
            "description": "%config.runtime.builtin.bit32%",
            "enum": [
              "default",
              "enable",
              "disable"
            ],
            "type": "string"
          },
          "builtin": {
            "default": "default",
            "description": "%config.runtime.builtin.builtin%",
            "enum": [
              "default",
              "enable",
              "disable"
            ],
            "type": "string"
          },
          "coroutine": {
            "default": "default",
            "description": "%config.runtime.builtin.coroutine%",
            "enum": [
              "default",
              "enable",
              "disable"
            ],
            "type": "string"
          },
          "debug": {
            "default": "default",
            "description": "%config.runtime.builtin.debug%",
            "enum": [
              "default",
              "enable",
              "disable"
            ],
            "type": "string"
          },
          "ffi": {
            "default": "default",
            "description": "%config.runtime.builtin.ffi%",
            "enum": [
              "default",
              "enable",
              "disable"
            ],
            "type": "string"
          },
          "io": {
            "default": "default",
            "description": "%config.runtime.builtin.io%",
            "enum": [
              "default",
              "enable",
              "disable"
            ],
            "type": "string"
          },
          "jit": {
            "default": "default",
            "description": "%config.runtime.builtin.jit%",
            "enum": [
              "default",
              "enable",
              "disable"
            ],
            "type": "string"
          },
          "math": {
            "default": "default",
            "description": "%config.runtime.builtin.math%",
            "enum": [
              "default",
              "enable",
              "disable"
            ],
            "type": "string"
          },
          "os": {
            "default": "default",
            "description": "%config.runtime.builtin.os%",
            "enum": [
              "default",
              "enable",
              "disable"
            ],
            "type": "string"
          },
          "package": {
            "default": "default",
            "description": "%config.runtime.builtin.package%",
            "enum": [
              "default",
              "enable",
              "disable"
            ],
            "type": "string"
          },
          "string": {
            "default": "default",
            "description": "%config.runtime.builtin.string%",
            "enum": [
              "default",
              "enable",
              "disable"
            ],
            "type": "string"
          },
          "string.buffer": {
            "default": "default",
            "description": "%config.runtime.builtin.string.buffer%",
            "enum": [
              "default",
              "enable",
              "disable"
            ],
            "type": "string"
          },
          "table": {
            "default": "default",
            "description": "%config.runtime.builtin.table%",
            "enum": [
              "default",
              "enable",
              "disable"
            ],
            "type": "string"
          },
          "table.clear": {
            "default": "default",
            "description": "%config.runtime.builtin.table.clear%",
            "enum": [
              "default",
              "enable",
              "disable"
            ],
            "type": "string"
          },
          "table.new": {
            "default": "default",
            "description": "%config.runtime.builtin.table.new%",
            "enum": [
              "default",
              "enable",
              "disable"
            ],
            "type": "string"
          },
          "utf8": {
            "default": "default",
            "description": "%config.runtime.builtin.utf8%",
            "enum": [
              "default",
              "enable",
              "disable"
            ],
            "type": "string"
          }
        },
        "scope": 4,
        "title": "builtin",
        "type": "object"
      },
      "Lua.runtime.fileEncoding": {
        "default": "utf8",
        "enum": [
          "utf8",
          "ansi",
          "utf16le",
          "utf16be"
        ],
        "markdownDescription": "File encoding. The `ansi` option is only available under the `Windows` platform.",
        "markdownEnumDescriptions": [
          "%config.runtime.fileEncoding.utf8%",
          "%config.runtime.fileEncoding.ansi%",
          "%config.runtime.fileEncoding.utf16le%",
          "%config.runtime.fileEncoding.utf16be%"
        ],
        "scope": 4,
        "type": "string"
      },
      "Lua.runtime.meta": {
        "default": "${version} ${language} ${encoding}",
        "markdownDescription": "Format of the directory name of the meta files.",
        "scope": 4,
        "type": "string"
      },
      "Lua.runtime.nonstandardSymbol": {
        "default": [],
        "items": {
          "enum": [
            "//",
            "/**/",
            "`",
            "+=",
            "-=",
            "*=",
            "/=",
            "%=",
            "^=",
            "//=",
            "|=",
            "&=",
            "<<=",
            ">>=",
            "||",
            "&&",
            "!",
            "!=",
            "continue"
          ],
          "type": "string"
        },
        "markdownDescription": "Supports non-standard symbols. Make sure that your runtime environment supports these symbols.",
        "scope": 4,
        "type": "array"
      },
      "Lua.runtime.path": {
        "default": [
          "?.lua",
          "?/init.lua"
        ],
        "items": {
          "type": "string"
        },
        "markdownDescription": "When using `require`, how to find the file based on the input name.\nSetting this config to `?/init.lua` means that when you enter `require 'myfile'`, `${workspace}/myfile/init.lua` will be searched from the loaded files.\nif `runtime.pathStrict` is `false`, `${workspace}/**/myfile/init.lua` will also be searched.\nIf you want to load files outside the workspace, you need to set `Lua.workspace.library` first.\n",
        "scope": 4,
        "type": "array"
      },
      "Lua.runtime.pathStrict": {
        "default": false,
        "markdownDescription": "When enabled, `runtime.path` will only search the first level of directories, see the description of `runtime.path`.",
        "scope": 4,
        "type": "boolean"
      },
      "Lua.runtime.plugin": {
        "default": "",
        "markdownDescription": "Plugin path. Please read [wiki](https://github.com/sumneko/lua-language-server/wiki/Plugins) to learn more.",
        "scope": 4,
        "type": "string"
      },
      "Lua.runtime.pluginArgs": {
        "default": [],
        "items": {
          "type": "string"
        },
        "markdownDescription": "Additional arguments for the plugin.",
        "scope": 4,
        "type": "array"
      },
      "Lua.runtime.special": {
        "additionalProperties": false,
        "default": {},
        "markdownDescription": "The custom global variables are regarded as some special built-in variables, and the language server will provide special support\nThe following example shows that 'include' is treated as' require '.\n```json\n\"Lua.runtime.special\" : {\n    \"include\" : \"require\"\n}\n```\n",
        "patternProperties": {
          ".*": {
            "default": "require",
            "enum": [
              "_G",
              "rawset",
              "rawget",
              "setmetatable",
              "require",
              "dofile",
              "loadfile",
              "pcall",
              "xpcall",
              "assert",
              "error",
              "type"
            ],
            "type": "string"
          }
        },
        "scope": 4,
        "title": "special",
        "type": "object"
      },
      "Lua.runtime.unicodeName": {
        "default": false,
        "markdownDescription": "Allows Unicode characters in name.",
        "scope": 4,
        "type": "boolean"
      },
      "Lua.runtime.version": {
        "default": "Lua 5.4",
        "enum": [
          "Lua 5.1",
          "Lua 5.2",
          "Lua 5.3",
          "Lua 5.4",
          "LuaJIT"
        ],
        "markdownDescription": "Lua runtime version.",
        "markdownEnumDescriptions": [
          "%config.runtime.version.Lua 5.1%",
          "%config.runtime.version.Lua 5.2%",
          "%config.runtime.version.Lua 5.3%",
          "%config.runtime.version.Lua 5.4%",
          "%config.runtime.version.LuaJIT%"
        ],
        "scope": 4,
        "type": "string"
      },
      "Lua.semantic.annotation": {
        "default": true,
        "markdownDescription": "Semantic coloring of type annotations.",
        "scope": 4,
        "type": "boolean"
      },
      "Lua.semantic.enable": {
        "default": true,
        "markdownDescription": "Enable semantic color. You may need to set `editor.semanticHighlighting.enabled` to `true` to take effect.",
        "scope": 4,
        "type": "boolean"
      },
      "Lua.semantic.keyword": {
        "default": false,
        "markdownDescription": "Semantic coloring of keywords/literals/operators. You only need to enable this feature if your editor cannot do syntax coloring.",
        "scope": 4,
        "type": "boolean"
      },
      "Lua.semantic.variable": {
        "default": true,
        "markdownDescription": "Semantic coloring of variables/fields/parameters.",
        "scope": 4,
        "type": "boolean"
      },
      "Lua.signatureHelp.enable": {
        "default": true,
        "markdownDescription": "Enable signature help.",
        "scope": 4,
        "type": "boolean"
      },
      "Lua.spell.dict": {
        "default": [],
        "items": {
          "type": "string"
        },
        "markdownDescription": "Custom words for spell checking.",
        "scope": 4,
        "type": "array"
      },
      "Lua.telemetry.enable": {
        "default": null,
        "markdownDescription": "Enable telemetry to send your editor information and error logs over the network. Read our privacy policy [here](https://github.com/sumneko/lua-language-server/wiki/Home#privacy).\n",
        "scope": 4,
        "tags": [
          "telemetry"
        ],
        "type": [
          "boolean",
          "null"
        ]
      },
      "Lua.type.castNumberToInteger": {
        "default": true,
        "markdownDescription": "Allowed to assign the `number` type to the `integer` type.",
        "scope": 4,
        "type": "boolean"
      },
      "Lua.type.weakNilCheck": {
        "default": false,
        "markdownDescription": "When checking the type of union type, ignore the `nil` in it.\n\nWhen this setting is `false`, the `number|nil` type cannot be assigned to the `number` type. It can be with `true`.\n",
        "scope": 4,
        "type": "boolean"
      },
      "Lua.type.weakUnionCheck": {
        "default": false,
        "markdownDescription": "Once one subtype of a union type meets the condition, the union type also meets the condition.\n\nWhen this setting is `false`, the `number|boolean` type cannot be assigned to the `number` type. It can be with `true`.\n",
        "scope": 4,
        "type": "boolean"
      },
      "Lua.typeFormat.config": {
        "additionalProperties": false,
        "markdownDescription": "%config.typeFormat.config%",
        "properties": {
          "auto_complete_end": {
            "default": "true",
            "description": "%config.typeFormat.config.auto_complete_end%",
            "type": "string"
          },
          "auto_complete_table_sep": {
            "default": "true",
            "description": "%config.typeFormat.config.auto_complete_table_sep%",
            "type": "string"
          },
          "format_line": {
            "default": "true",
            "description": "%config.typeFormat.config.format_line%",
            "type": "string"
          }
        },
        "scope": 4,
        "title": "config",
        "type": "object"
      },
      "Lua.window.progressBar": {
        "default": true,
        "markdownDescription": "Show progress bar in status bar.",
        "scope": 4,
        "type": "boolean"
      },
      "Lua.window.statusBar": {
        "default": true,
        "markdownDescription": "Show extension status in status bar.",
        "scope": 4,
        "type": "boolean"
      },
      "Lua.workspace.checkThirdParty": {
        "default": true,
        "markdownDescription": "Automatic detection and adaptation of third-party libraries, currently supported libraries are:\n\n* OpenResty\n* Cocos4.0\n* LÖVE\n* LÖVR\n* skynet\n* Jass\n",
        "scope": 4,
        "type": "boolean"
      },
      "Lua.workspace.ignoreDir": {
        "default": [
          ".vscode"
        ],
        "items": {
          "type": "string"
        },
        "markdownDescription": "Ignored files and directories (Use `.gitignore` grammar).",
        "scope": 4,
        "type": "array"
      },
      "Lua.workspace.ignoreSubmodules": {
        "default": true,
        "markdownDescription": "Ignore submodules.",
        "scope": 4,
        "type": "boolean"
      },
      "Lua.workspace.library": {
        "default": [],
        "items": {
          "type": "string"
        },
        "markdownDescription": "In addition to the current workspace, which directories will load files from. The files in these directories will be treated as externally provided code libraries, and some features (such as renaming fields) will not modify these files.",
        "scope": 4,
        "type": "array"
      },
      "Lua.workspace.maxPreload": {
        "default": 5000,
        "markdownDescription": "Max preloaded files.",
        "scope": 4,
        "type": "integer"
      },
      "Lua.workspace.preloadFileSize": {
        "default": 500,
        "markdownDescription": "Skip files larger than this value (KB) when preloading.",
        "scope": 4,
        "type": "integer"
      },
      "Lua.workspace.supportScheme": {
        "default": [
          "file",
          "untitled",
          "git"
        ],
        "items": {
          "type": "string"
        },
        "markdownDescription": "Provide language server for the Lua files of the following scheme.",
        "scope": 4,
        "type": "array"
      },
      "Lua.workspace.useGitIgnore": {
        "default": true,
        "markdownDescription": "Ignore files list in `.gitignore` .",
        "scope": 4,
        "type": "boolean"
      },
      "Lua.workspace.userThirdParty": {
        "default": [],
        "items": {
          "type": "string"
        },
        "markdownDescription": "Add private third-party library configuration file paths here, please refer to the built-in [configuration file path](https://github.com/sumneko/lua-language-server/tree/master/meta/3rd)",
        "scope": 4,
        "type": "array"
      }
    },
    "title": "Lua",
    "type": "object"
  }
];

export { lua as default };
