var scopeName = "source.ocaml.merlin";
var fileTypes = [
	"merlin"
];
var patterns = [
	{
		include: "#comment"
	},
	{
		include: "#directory"
	},
	{
		include: "#flag"
	},
	{
		include: "#package"
	}
];
var repository = {
	comment: {
		begin: "#",
		end: "$",
		name: "comment.line.merlin"
	},
	directory: {
		begin: "\\b(B|S)\\b",
		end: "$",
		beginCaptures: {
			"1": {
				name: "keyword.other.merlin"
			}
		},
		name: "string.other.merlin",
		patterns: [
			{
				match: "[:./  \\\\]",
				name: "keyword.other.path.merlin"
			},
			{
				match: "[*?]",
				name: "keyword.other.glob.merlin"
			}
		]
	},
	flag: {
		begin: "\\b(FLG)\\b",
		end: "$",
		beginCaptures: {
			"1": {
				name: "keyword.other.merlin"
			}
		},
		patterns: [
			{
				begin: "\"",
				end: "\"",
				name: "string.quoted.double.merlin"
			},
			{
				match: "([\\-\\+])\\b(?:([[:digit:]]+)|([[:lower:]][[:word:]]*))\\b",
				captures: {
					"1": {
						name: "keyword.other.merlin"
					},
					"2": {
						name: "constant.language.merlin"
					},
					"3": {
						name: "variable.parameter.merlin"
					}
				}
			}
		]
	},
	"package": {
		begin: "\\b(PKG)\\b",
		end: "$",
		beginCaptures: {
			"1": {
				name: "storage.type.merlin"
			}
		},
		patterns: [
			{
				match: "(?<![\\-\\+])\\b([[:lower:]][-[:word:]]*)\\b[[:space:]]*(\\.)?",
				captures: {
					"1": {
						name: "entity.name.class.merlin"
					},
					"2": {
						name: "keyword.other.merlin"
					}
				}
			}
		]
	}
};
var information_for_contributors = [
	"This file has been converted from https://github.com/ocamllabs/vscode-ocaml-platform/blob/master/",
	"If you want to provide a fix or improvement, please create a pull request against the original repository.",
	"Once accepted there, we are happy to receive an update request."
];
var merlin = {
	scopeName: scopeName,
	fileTypes: fileTypes,
	patterns: patterns,
	repository: repository,
	information_for_contributors: information_for_contributors
};

export { merlin as default, fileTypes, information_for_contributors, patterns, repository, scopeName };
