var scopeName = "source.ocaml.oasis";
var fileTypes = [
	"_oasis"
];
var patterns = [
	{
		include: "#comments"
	},
	{
		include: "#fields"
	},
	{
		include: "#sections"
	},
	{
		include: "#conditionals"
	},
	{
		include: "#substitution"
	}
];
var repository = {
	comments: {
		comment: "line comment",
		name: "comment.line.oasis",
		begin: "#",
		end: "$"
	},
	fields: {
		comment: "labeled field",
		match: "^[[:space:]]*([[:word:]]+)(:|\\+:|\\$:)",
		captures: {
			"1": {
				name: "entity.name.tag.oasis"
			},
			"2": {
				name: "keyword.operator.oasis"
			}
		}
	},
	sections: {
		comment: "labeled section",
		begin: "^[[:space:]]*(Flag|Library|Object|Executable|Document|Test|SourceRepository)",
		beginCaptures: {
			"1": {
				name: "keyword.other.oasis"
			}
		},
		end: "$",
		contentName: "string.other.oasis"
	},
	conditionals: {
		patterns: [
			{
				comment: "if condition",
				name: "keyword.other.oasis",
				match: "\\b(if|else)\\b"
			},
			{
				comment: "operators",
				name: "keyword.operator.oasis",
				match: "(!|&&|\\|\\|)"
			},
			{
				comment: "boolean",
				name: "constant.language.oasis",
				match: "\\b(true|false)\\b"
			},
			{
				comment: "tests",
				begin: "\\b(os_type|system|architecture|ccomp_type|ocaml_version|flag)\\(",
				end: "\\)",
				beginCaptures: {
					"1": {
						name: "entity.name.function.oasis"
					}
				}
			}
		]
	},
	substitution: {
		match: "\\$[[:word:]]+",
		name: "constant.language.oasis"
	}
};
var information_for_contributors = [
	"This file has been converted from https://github.com/ocamllabs/vscode-ocaml-platform/blob/master/",
	"If you want to provide a fix or improvement, please create a pull request against the original repository.",
	"Once accepted there, we are happy to receive an update request."
];
var oasis = {
	scopeName: scopeName,
	fileTypes: fileTypes,
	patterns: patterns,
	repository: repository,
	information_for_contributors: information_for_contributors
};

export { oasis as default, fileTypes, information_for_contributors, patterns, repository, scopeName };
