var comments = {
	lineComment: "#",
	blockComment: [
		"<#",
		"#>"
	]
};
var brackets = [
	[
		"{",
		"}"
	],
	[
		"[",
		"]"
	],
	[
		"(",
		")"
	]
];
var autoClosingPairs = [
	[
		"{",
		"}"
	],
	[
		"[",
		"]"
	],
	[
		"(",
		")"
	],
	{
		open: "@'",
		close: "\n'@",
		notIn: [
			"string",
			"comment"
		]
	},
	{
		open: "@\"",
		close: "\n\"@",
		notIn: [
			"string",
			"comment"
		]
	},
	{
		open: "\"",
		close: "\"",
		notIn: [
			"string"
		]
	},
	{
		open: "'",
		close: "'",
		notIn: [
			"string",
			"comment"
		]
	},
	[
		"<#",
		"#>"
	]
];
var surroundingPairs = [
	[
		"{",
		"}"
	],
	[
		"[",
		"]"
	],
	[
		"(",
		")"
	],
	[
		"\"",
		"\""
	],
	[
		"'",
		"'"
	]
];
var folding = {
	markers: {
		start: "^\\s*#[rR]egion\\b",
		end: "^\\s*#[eE]nd[rR]egion\\b"
	}
};
var powershell = {
	comments: comments,
	brackets: brackets,
	autoClosingPairs: autoClosingPairs,
	surroundingPairs: surroundingPairs,
	folding: folding
};

export { autoClosingPairs, brackets, comments, powershell as default, folding, surroundingPairs };
