var scopeName = "svelte.pug.dotblock";
var fileTypes = [
];
var injectionSelector = "L:text.block.pug -meta.embedded.ts";
var patterns = [
	{
		include: "#interp-object-literal"
	},
	{
		include: "#interp"
	}
];
var repository = {
	"interp-object-literal": {
		contentName: "meta.interpolation meta.embedded.ts",
		begin: "(?![!$#]){\\s*?(?={)",
		beginCaptures: {
			"0": {
				name: "punctuation.section.interpolation.begin"
			}
		},
		end: "(?<=})\\s*?}",
		endCaptures: {
			"0": {
				name: "punctuation.section.interpolation.end"
			}
		},
		patterns: [
			{
				include: "source.ts#object-literal"
			}
		]
	},
	interp: {
		contentName: "meta.interpolation meta.embedded.ts",
		begin: "(?![!$#]){",
		beginCaptures: {
			"0": {
				name: "punctuation.section.interpolation.begin"
			}
		},
		end: "}",
		endCaptures: {
			"0": {
				name: "punctuation.section.interpolation.end"
			}
		},
		patterns: [
			{
				include: "source.ts"
			}
		]
	}
};
var information_for_contributors = [
	"This file has been converted from https://github.com/sveltejs/language-tools/blob/master/packages/svelte-vscode/",
	"If you want to provide a fix or improvement, please create a pull request against the original repository.",
	"Once accepted there, we are happy to receive an update request."
];
var pugSvelteDotblock = {
	scopeName: scopeName,
	fileTypes: fileTypes,
	injectionSelector: injectionSelector,
	patterns: patterns,
	repository: repository,
	information_for_contributors: information_for_contributors
};

export { pugSvelteDotblock as default, fileTypes, information_for_contributors, injectionSelector, patterns, repository, scopeName };
