var scopeName = "svelte.pug.tags";
var fileTypes = [
];
var injectionSelector = "L:text.pug meta.tag.other -meta.embedded.ts";
var patterns = [
	{
		include: "#interp-object-literal"
	},
	{
		include: "#interp"
	},
	{
		include: "#attr-function"
	},
	{
		include: "#attr-interp"
	},
	{
		include: "#attr-interp-invalid-quotes"
	},
	{
		include: "#attr-interp-invalid-noquotes"
	},
	{
		include: "#attr-event"
	},
	{
		include: "#attr-variable"
	}
];
var repository = {
	"interp-object-literal": {
		contentName: "meta.interpolation meta.embedded.ts",
		begin: "(?![!$#]){\\s*?(?={)",
		beginCaptures: {
			"0": {
				name: "punctuation.section.interpolation.begin"
			}
		},
		end: "(?<=})\\s*?}",
		endCaptures: {
			"0": {
				name: "punctuation.section.interpolation.end"
			}
		},
		patterns: [
			{
				include: "source.ts#object-literal"
			}
		]
	},
	interp: {
		contentName: "meta.interpolation meta.embedded.ts",
		begin: "(?![!$#]){",
		beginCaptures: {
			"0": {
				name: "punctuation.section.interpolation.begin"
			}
		},
		end: "}",
		endCaptures: {
			"0": {
				name: "punctuation.section.interpolation.end"
			}
		},
		patterns: [
			{
				include: "source.ts"
			}
		]
	},
	"attr-interp": {
		match: "\\b(?<=[\\w$\\-_]*)\\s*?(!=|=)\\s*?([`'\"])((?![$!#]){.*})(\\k<2>)",
		captures: {
			"1": {
				patterns: [
					{
						match: "=",
						name: "invalid.illegal"
					},
					{
						match: "!=",
						name: "keyword.operator.assignment"
					}
				]
			},
			"2": {
				name: "punctuation.section.interpolation.begin"
			},
			"3": {
				patterns: [
					{
						include: "#interp"
					}
				]
			},
			"4": {
				name: "punctuation.section.interpolation.begin"
			}
		}
	},
	"attr-interp-invalid-quotes": {
		match: "\\b(?<=[\\w$\\-_]*)\\s*?(!=|=)\\s*?([`'\"])((?![$!#]){.*})(?!\\k<2>)",
		captures: {
			"1": {
				patterns: [
					{
						match: "=",
						name: "invalid.illegal"
					},
					{
						match: "!=",
						name: "keyword.operator.assignment"
					}
				]
			},
			"2": {
				name: "punctuation.section.interpolation.begin"
			},
			"3": {
				name: "invalid.illegal"
			},
			"4": {
				name: "invalid.illegal"
			}
		}
	},
	"attr-interp-invalid-noquotes": {
		match: "\\b(?<=[\\w$\\-_]*)\\s*?(!=|=)\\s*?(?![`'\"])((?![$!#]){.*})(?![`'\"])",
		captures: {
			"1": {
				patterns: [
					{
						match: "=",
						name: "invalid.illegal"
					},
					{
						match: "!=",
						name: "keyword.operator.assignment"
					}
				]
			},
			"2": {
				name: "invalid.illegal"
			},
			"3": {
				patterns: [
					{
						include: "#interp"
					}
				]
			},
			"4": {
				name: "invalid.illegal"
			}
		}
	},
	"attr-function": {
		match: "\\b(use|transition|in|out|animate)(:)(\\w+)",
		captures: {
			"1": {
				name: "entity.other.attribute-name"
			},
			"2": {
				name: "keyword.operator.assignment"
			},
			"3": {
				name: "variable.function"
			}
		}
	},
	"attr-event": {
		match: "\\b(on)(:)(\\w+)",
		captures: {
			"1": {
				name: "entity.other.attribute-name"
			},
			"2": {
				name: "keyword.operator.assignment"
			},
			"3": {
				name: "entity.name.type"
			}
		}
	},
	"attr-variable": {
		match: "\\b(bind|class|let)(:)(\\w+)",
		captures: {
			"1": {
				name: "entity.other.attribute-name"
			},
			"2": {
				name: "keyword.operator.assignment"
			},
			"3": {
				name: "variable.parameter"
			}
		}
	}
};
var information_for_contributors = [
	"This file has been converted from https://github.com/sveltejs/language-tools/blob/master/packages/svelte-vscode/",
	"If you want to provide a fix or improvement, please create a pull request against the original repository.",
	"Once accepted there, we are happy to receive an update request."
];
var pugSvelteTags = {
	scopeName: scopeName,
	fileTypes: fileTypes,
	injectionSelector: injectionSelector,
	patterns: patterns,
	repository: repository,
	information_for_contributors: information_for_contributors
};

export { pugSvelteTags as default, fileTypes, information_for_contributors, injectionSelector, patterns, repository, scopeName };
