var comments = {
	lineComment: "#",
	blockComment: [
		"\"\"\"",
		"\"\"\""
	]
};
var brackets = [
	[
		"{",
		"}"
	],
	[
		"[",
		"]"
	],
	[
		"(",
		")"
	]
];
var autoClosingPairs = [
	{
		open: "{",
		close: "}"
	},
	{
		open: "[",
		close: "]"
	},
	{
		open: "(",
		close: ")"
	},
	{
		open: "\"",
		close: "\"",
		notIn: [
			"string"
		]
	},
	{
		open: "r\"",
		close: "\"",
		notIn: [
			"string",
			"comment"
		]
	},
	{
		open: "R\"",
		close: "\"",
		notIn: [
			"string",
			"comment"
		]
	},
	{
		open: "u\"",
		close: "\"",
		notIn: [
			"string",
			"comment"
		]
	},
	{
		open: "U\"",
		close: "\"",
		notIn: [
			"string",
			"comment"
		]
	},
	{
		open: "f\"",
		close: "\"",
		notIn: [
			"string",
			"comment"
		]
	},
	{
		open: "F\"",
		close: "\"",
		notIn: [
			"string",
			"comment"
		]
	},
	{
		open: "b\"",
		close: "\"",
		notIn: [
			"string",
			"comment"
		]
	},
	{
		open: "B\"",
		close: "\"",
		notIn: [
			"string",
			"comment"
		]
	},
	{
		open: "'",
		close: "'",
		notIn: [
			"string",
			"comment"
		]
	},
	{
		open: "r'",
		close: "'",
		notIn: [
			"string",
			"comment"
		]
	},
	{
		open: "R'",
		close: "'",
		notIn: [
			"string",
			"comment"
		]
	},
	{
		open: "u'",
		close: "'",
		notIn: [
			"string",
			"comment"
		]
	},
	{
		open: "U'",
		close: "'",
		notIn: [
			"string",
			"comment"
		]
	},
	{
		open: "f'",
		close: "'",
		notIn: [
			"string",
			"comment"
		]
	},
	{
		open: "F'",
		close: "'",
		notIn: [
			"string",
			"comment"
		]
	},
	{
		open: "b'",
		close: "'",
		notIn: [
			"string",
			"comment"
		]
	},
	{
		open: "B'",
		close: "'",
		notIn: [
			"string",
			"comment"
		]
	},
	{
		open: "`",
		close: "`",
		notIn: [
			"string"
		]
	}
];
var surroundingPairs = [
	[
		"{",
		"}"
	],
	[
		"[",
		"]"
	],
	[
		"(",
		")"
	],
	[
		"\"",
		"\""
	],
	[
		"'",
		"'"
	],
	[
		"`",
		"`"
	]
];
var folding = {
	offSide: true,
	markers: {
		start: "^\\s*#\\s*region\\b",
		end: "^\\s*#\\s*endregion\\b"
	}
};
var onEnterRules = [
	{
		beforeText: "^\\s*(?:def|class|for|if|elif|else|while|try|with|finally|except|async).*?:\\s*$",
		action: {
			indent: "indent"
		}
	}
];
var python = {
	comments: comments,
	brackets: brackets,
	autoClosingPairs: autoClosingPairs,
	surroundingPairs: surroundingPairs,
	folding: folding,
	onEnterRules: onEnterRules
};

export { autoClosingPairs, brackets, comments, python as default, folding, onEnterRules, surroundingPairs };
