var comments = {
	blockComment: [
		"/*",
		"*/"
	],
	lineComment: "//"
};
var brackets = [
	[
		"{",
		"}"
	],
	[
		"[",
		"]"
	],
	[
		"(",
		")"
	]
];
var autoClosingPairs = [
	{
		open: "{",
		close: "}",
		notIn: [
			"string",
			"comment"
		]
	},
	{
		open: "[",
		close: "]",
		notIn: [
			"string",
			"comment"
		]
	},
	{
		open: "(",
		close: ")",
		notIn: [
			"string",
			"comment"
		]
	},
	{
		open: "\"",
		close: "\"",
		notIn: [
			"string",
			"comment"
		]
	},
	{
		open: "'",
		close: "'",
		notIn: [
			"string",
			"comment"
		]
	}
];
var surroundingPairs = [
	[
		"{",
		"}"
	],
	[
		"[",
		"]"
	],
	[
		"(",
		")"
	],
	[
		"\"",
		"\""
	],
	[
		"'",
		"'"
	]
];
var folding = {
	markers: {
		start: "^\\s*\\/\\*\\s*#region\\b\\s*(.*?)\\s*\\*\\/",
		end: "^\\s*\\/\\*\\s*#endregion\\b.*\\*\\/"
	}
};
var indentationRules = {
	increaseIndentPattern: "(^.*\\{[^}]*$)",
	decreaseIndentPattern: "^\\s*\\}"
};
var wordPattern = "(#?-?\\d*\\.\\d\\w*%?)|(::?[\\w-]*(?=[^,{;]*[,{]))|(([@$#.!])?[\\w-?]+%?|[@#!$.])";
var onEnterRules = [
	{
		beforeText: "^[\\s]*///.*$",
		action: {
			indent: "none",
			appendText: "/// "
		}
	}
];
var scss = {
	comments: comments,
	brackets: brackets,
	autoClosingPairs: autoClosingPairs,
	surroundingPairs: surroundingPairs,
	folding: folding,
	indentationRules: indentationRules,
	wordPattern: wordPattern,
	onEnterRules: onEnterRules
};

export { autoClosingPairs, brackets, comments, scss as default, folding, indentationRules, onEnterRules, surroundingPairs, wordPattern };
