var comments = {
	blockComment: [
		"<!--",
		"-->"
	]
};
var brackets = [
	[
		"<!--",
		"-->"
	],
	[
		"<",
		">"
	],
	[
		"{",
		"}"
	],
	[
		"(",
		")"
	]
];
var autoClosingPairs = [
	{
		open: "{",
		close: "}"
	},
	{
		open: "[",
		close: "]"
	},
	{
		open: "(",
		close: ")"
	},
	{
		open: "'",
		close: "'"
	},
	{
		open: "\"",
		close: "\""
	},
	{
		open: "<!--",
		close: "-->",
		notIn: [
			"comment",
			"string"
		]
	},
	{
		open: "`",
		close: "`",
		notIn: [
			"string",
			"comment"
		]
	},
	{
		open: "/**",
		close: " */",
		notIn: [
			"string"
		]
	}
];
var autoCloseBefore = ";:.,=}])><`'\" \n\t";
var surroundingPairs = [
	{
		open: "'",
		close: "'"
	},
	{
		open: "\"",
		close: "\""
	},
	{
		open: "{",
		close: "}"
	},
	{
		open: "[",
		close: "]"
	},
	{
		open: "(",
		close: ")"
	},
	{
		open: "<",
		close: ">"
	},
	[
		"`",
		"`"
	]
];
var colorizedBracketPairs = [
];
var folding = {
	markers: {
		start: "^\\s*<!--\\s*#region\\b.*-->",
		end: "^\\s*<!--\\s*#endregion\\b.*-->"
	}
};
var wordPattern = "(-?\\d*\\.\\d\\w*)|([^\\`\\~\\!\\@\\$\\^\\&\\*\\(\\)\\=\\+\\[\\{\\]\\}\\\\\\|\\;\\:\\'\\\"\\,\\.\\<\\>\\/\\s]+)";
var onEnterRules = [
	{
		beforeText: {
			pattern: "<(?!(?:area|base|br|col|embed|hr|img|input|keygen|link|menuitem|meta|param|source|track|wbr|script|style))([_:\\w][_:\\w-.\\d]*)(?:(?:[^'\"/>]|\"[^\"]*\"|'[^']*')*?(?!\\/)>)[^<]*$",
			flags: "i"
		},
		afterText: {
			pattern: "^<\\/([_:\\w][_:\\w-.\\d]*)\\s*>",
			flags: "i"
		},
		action: {
			indent: "indentOutdent"
		}
	},
	{
		beforeText: {
			pattern: "<(?!(?:area|base|br|col|embed|hr|img|input|keygen|link|menuitem|meta|param|source|track|wbr|script|style))([_:\\w][_:\\w-.\\d]*)(?:(?:[^'\"/>]|\"[^\"]*\"|'[^']*')*?(?!\\/)>)[^<]*$",
			flags: "i"
		},
		action: {
			indent: "indent"
		}
	}
];
var indentationRules = {
	increaseIndentPattern: "<(?!\\?|(?:area|base|br|col|frame|hr|html|img|input|keygen|link|menuitem|meta|param|source|track|wbr|script|style)\\b|[^>]*\\/>)([-_\\.A-Za-z0-9]+)(?=\\s|>)\\b[^>]*>(?!\\s*\\()(?!.*<\\/\\1>)|<!--(?!.*-->)|\\{[^}\"']*$",
	decreaseIndentPattern: "^\\s*(<\\/(?!html)[-_\\.A-Za-z0-9]+\\b[^>]*>|-->|\\})"
};
var vue = {
	comments: comments,
	brackets: brackets,
	autoClosingPairs: autoClosingPairs,
	autoCloseBefore: autoCloseBefore,
	surroundingPairs: surroundingPairs,
	colorizedBracketPairs: colorizedBracketPairs,
	folding: folding,
	wordPattern: wordPattern,
	onEnterRules: onEnterRules,
	indentationRules: indentationRules
};

export { autoCloseBefore, autoClosingPairs, brackets, colorizedBracketPairs, comments, vue as default, folding, indentationRules, onEnterRules, surroundingPairs, wordPattern };
