var comments = {
	blockComment: [
		"<!--",
		"-->"
	]
};
var brackets = [
	[
		"<!--",
		"-->"
	],
	[
		"<",
		">"
	],
	[
		"{",
		"}"
	],
	[
		"(",
		")"
	]
];
var autoClosingPairs = [
	{
		open: "{",
		close: "}"
	},
	{
		open: "[",
		close: "]"
	},
	{
		open: "(",
		close: ")"
	},
	{
		open: "\"",
		close: "\"",
		notIn: [
			"string"
		]
	},
	{
		open: "'",
		close: "'",
		notIn: [
			"string"
		]
	},
	{
		open: "<!--",
		close: "-->",
		notIn: [
			"comment",
			"string"
		]
	},
	{
		open: "<![CDATA[",
		close: "]]>",
		notIn: [
			"comment",
			"string"
		]
	}
];
var surroundingPairs = [
	{
		open: "'",
		close: "'"
	},
	{
		open: "\"",
		close: "\""
	},
	{
		open: "{",
		close: "}"
	},
	{
		open: "[",
		close: "]"
	},
	{
		open: "(",
		close: ")"
	},
	{
		open: "<",
		close: ">"
	}
];
var colorizedBracketPairs = [
];
var folding = {
	markers: {
		start: "^\\s*<!--\\s*#region\\b.*-->",
		end: "^\\s*<!--\\s*#endregion\\b.*-->"
	}
};
var wordPattern = {
	pattern: "(-?\\d*\\.\\d\\w*)|([^\\`\\~\\!\\@\\#\\$\\%\\^\\&\\*\\(\\)\\=\\+\\[\\{\\]\\}\\\\\\|\\;\\:\\'\\\"\\,\\.\\<\\>\\/\\?\\s]+)"
};
var xml = {
	comments: comments,
	brackets: brackets,
	autoClosingPairs: autoClosingPairs,
	surroundingPairs: surroundingPairs,
	colorizedBracketPairs: colorizedBracketPairs,
	folding: folding,
	wordPattern: wordPattern
};

export { autoClosingPairs, brackets, colorizedBracketPairs, comments, xml as default, folding, surroundingPairs, wordPattern };
